##*************************************************************************##
##  CUBE        http://www.scalasca.org/                                   ##
##*************************************************************************##
##  Copyright (c) 2025                                                     ##
##  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          ##
##                                                                         ##
##  This software may be modified and distributed under the terms of       ##
##  a BSD-style license.  See the COPYING file in the package base         ##
##  directory for details.                                                 ##
##*************************************************************************##


# Cmake config file which is generated by autoconf and installed into
# /usr/lib64/cmake/CubeLib/CubeLibConfig.cmake

set(CubeLib_VERSION "4.9.0")
string(REGEX REPLACE "\\.$" "" CubeLib_VERSION ${CubeLib_VERSION})

# set PACKAGE_PREFIX_DIR to main installation directory
get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

# Create imported target CubeLib
add_library(CubeLib SHARED IMPORTED)
set_target_properties(CubeLib PROPERTIES
  INTERFACE_INCLUDE_DIRECTORIES "${PACKAGE_PREFIX_DIR}/include/cubelib"
)

set(LIBRARY_VERSION_STRING 13:0:0)
string(REPLACE ":" "." LIBRARY_VERSION_STRING ${LIBRARY_VERSION_STRING})
string(REGEX MATCH "^[0-9]+" LIBRARY_VERSION_MAJOR ${LIBRARY_VERSION_STRING})

set_target_properties(CubeLib PROPERTIES
  IMPORTED_LOCATION "/usr/lib64/libcube4.so.${LIBRARY_VERSION_STRING}"
  IMPORTED_SONAME "libcube4.so.${LIBRARY_VERSION_MAJOR}"
)

message(STATUS "CubeLib Version ${CubeLib_VERSION} found")
